#ifndef MOC_H
#define MOC_H
// <<< Use Configuration Wizard in Context Menu >>>
// <h> Set MOTOR_CONT1
// <o.0> SPFB_FILETER <0=> Disable <1=> Enable 
// <o.5> MPWMEN <0=> Disable <1=> Enable 
// <o.6> MPWMSEL <0=> From Register <1=> From SVPWM Register
// </h>
#define MOTOR_CONT1_REGS 0x61

// <h> Set MOTOR_CONT2
// <o.1> IAESOFEN <0=> Disable <1=> Enable 
// <o.4> SVPWMMODE <0=> SVPWM <1=> D-SVPWM 
// </h>
#define MOTOR_CONT2_REGS 0x36

// <h> Set MOTOR_CONT3
// <o.0> CPS_LMT_SEL <0=> Dead time compensation min duty limit is 2xdeadband <1=> Dead time compensation min duty limit is deadband
// <o.4..5> IDQ_FB_SEL <0=> Iq/Id direct feedback <1=> Two Iq/Id value average <2=> Four Iq/Id value average
// <o.6> SMO_CMP_VALUE <0=> Compare with MAX_SMC_ERR <1=> Compare with 0
// </h>
#define MOTOR_CONT3_REGS 0x91

// <h> Set SVPWM_AMP 
// <o> SVPWM_AMP <0-65535>
// </h>
#define SVPWM_AMP_REGS 0x4900

// <h> Set FG_CTRL
// <o.7> FG_EN <0=> Disable <1=> Enable
// <o.0..2> FGPULSE_SEL <0=> 1 pulses/cycle <1=> 2 pulses/cycle <2=> 4 pulses/cycle <3=> 8 pulses/cycle <4=> 12 pulses/cycle 
// </h>
#define FG_CTRL_REGS 0x00

// <h> Set PI_GAIN 
// <o.0> PLL KI Gain x16 <0=> Disable <1=> Enable
// <o.1> PLL KP Gain x16 <0=> Disable <1=> Enable
// <o.2> SPEED KI Gain x16 <0=> Disable <1=> Enable
// <o.3> SPEED KP Gain x16 <0=> Disable <1=> Enable
// <o.4> ID KI Gain x16 <0=> Disable <1=> Enable
// <o.5> ID KP Gain x16 <0=> Disable <1=> Enable
// <o.6> IQ KI Gain x16 <0=> Disable <1=> Enable
// <o.7> IQ KP Gain x16 <0=> Disable <1=> Enable
// </h>
#define PI_GAIN_REGS 0xA0

// <<< end of configuration section >>>
#endif