#ifndef INTERRUPT_H
#define INTERRUPT_H
// <<< Use Configuration Wizard in Context Menu >>>

// <e> Interrupt 0 : External Interrupt 0 Enable/Disable
	#define 	dIE0 	0
// <o> Set External interrupt 0 type control <0=> Low level <1=> Falling edge
	#define 	dIT0 	0
// </e>

// <e> Interrupt 1 : Timer0 Interrupt Enable/Disable
	#define 	dITR0 	1
// </e>

// <e> Interrupt 2 : External Interrupt 1 Enable/Disable
	#define 	dIE1 	0
// <o> Set External interrupt 1 type control <0=> Low level <1=> Falling edge
	#define 	dIT1 	1
// </e>

// <e> Interrupt 3 : Timer1 Interrupt Enable/Disable
	#define 	dITR1 	1
// </e>

// <e> Interrupt 4 : UART Interrupt Enable/Disable
	#define 	dIUR 	0
// </e>

// <e> Interrupt 5 : Timer2 Interrupt Enable/Disable
	#define 	dITR2 	1
// </e>

// <e> Interrupt 8 : OCP Interrupt Enable/Disable
// <i> It is recommended to enable
	#define 	dIOCP 	1
// </e>

// <e> Interrupt 9 : ADC Interrupt Enable/Disable
// <i> It is recommended to enable
	#define 	dIADC 	1
// </e>

// <e> Interrupt 10 : PWM_min Interrupt Enable/Disable
	#define 	dIPWM_min 	0
// </e>

// <e> Interrupt 11 : PWM_MAX Interrupt Enable/Disable
// <i> It is recommended to enable
	#define 	dIPWM_MAX 	1
// </e>

// <e> Interrupt 12 : IIC Interrupt Enable/Disable
	#define 	dIIIC 	0
// </e>

// <e> Interrupt 13 : LVDIF Interrupt Enable/Disable
	#define 	dILVF 	0
// </e>

// <e> Interrupt 14 : WDTIF Interrupt Enable/Disable
	#define 	dIWDF 	0
// </e>

// <e> Interrupt 15 : CAPTURE Interrupt Enable/Disable
	#define 	dICAP 	1
// </e>

// <<< end of configuration section >>>
extern void Interrupt_Init (void);
extern	xdata	unsigned int	ir_data[4];
extern	unsigned char			ir_counter;
extern	unsigned char 			ir_head;
extern	unsigned char			ir_data_shift_counter;
extern  bit	cap_test_flag;
extern  uint16   test_p;

#endif
